/*
 * Copyright(c) 2006 IWAMURO Motonori <vmi@nifty.com>
 * 
 * Created: 2006/03/05
 */
package jp.vmi.util;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import junit.framework.TestCase;

/**
 * test of RegexUtil
 */
public class RegexUtilTest extends TestCase {

    /**
     * main
     * 
     * @param args
     */
    public static void main(String[] args) {
        junit.textui.TestRunner.run(RegexUtilTest.class);
    }

    /**
     * Constructor for RegexUtilTest.
     * @param name
     */
    public RegexUtilTest(String name) {
        super(name);
    }

    /**
     * test of 'jp.vmi.util.RegexUtil.replaceFirst(String, Pattern, Filter)'
     */
    public final void testReplaceFirstStringPatternFilter() {
        String string = "abc123def456ghi789";
        Pattern pattern = Pattern.compile("(\\d+)");
        String result = RegexUtil.replaceFirst(string, pattern, new RegexUtil.Filter() {
            public void filter(StringBuffer sb, Matcher matcher) {
                sb.append(Integer.parseInt(matcher.group(1)) * 2);
            }
        });
        assertEquals(result, "abc246def456ghi789");
    }

    /**
     * test of 'jp.vmi.util.RegexUtil.replaceFirst(String, String, Filter)'
     */
    public final void testReplaceFirstStringStringFilter() {
        String string = "abc123def456ghi789";
        String regex = "(\\d+)";
        String result = RegexUtil.replaceFirst(string, regex, new RegexUtil.Filter() {
            public void filter(StringBuffer sb, Matcher matcher) {
                sb.append(Integer.parseInt(matcher.group(1)) * 2);
            }
        });
        assertEquals(result, "abc246def456ghi789");
    }

    /**
     * test of 'jp.vmi.util.RegexUtil.replaceAll(String, Pattern, Filter)'
     */
    public final void testReplaceAllStringPatternFilter() {
        String string = "abc123def456ghi789";
        Pattern pattern = Pattern.compile("(\\d+)");
        String result = RegexUtil.replaceAll(string, pattern, new RegexUtil.Filter() {
            public void filter(StringBuffer sb, Matcher matcher) {
                sb.append(Integer.parseInt(matcher.group(1)) * 2);
            }
        });
        assertEquals(result, "abc246def912ghi1578");
    }

    /**
     * test of 'jp.vmi.util.RegexUtil.replaceAll(String, String, Filter)'
     */
    public final void testReplaceAllStringStringFilter() {
        String string = "abc123def456ghi789";
        String regex = "(\\d+)";
        String result = RegexUtil.replaceAll(string, regex, new RegexUtil.Filter() {
            public void filter(StringBuffer sb, Matcher matcher) {
                sb.append(Integer.parseInt(matcher.group(1)) * 2);
            }
        });
        assertEquals(result, "abc246def912ghi1578");
    }

}
